#ifndef AWINDOW_H
#define AWINDOW_H

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include "aguix.h"
#include "aguixdefs.h"
#include "lowlevelfunc.h"
#include "text.h"

class AWindow {
public:
  AWindow(AGUIX *parent);
  ~AWindow();
  Display *getDisplay();
  Window getWindow();
  Screen *getScreen();
  GC *getGC();
  AGUIX *getAGUIX();
  int setResizable(int state);
  void setMaxSize(int mwidth,int mheight);
  void setMinSize(int mwidth,int mheight);
  int create(AWindow *parent,int x,int y,int width,int height,int bg,char *title);
  void close();
  void show();
  void show(Window);
  void hide();
  void hide(Window);
  int isVisible();
  void minimize();
  void toFront();
  void move(int x,int y);
  int getXPosition();
  int getYPosition();
  void resize(int width,int height);
  void sizeChanged(int width,int height);
  int getWidth();
  int getHeight();
  void redraw();
  char *getTitle();
  void setTitle(const char *new_title);
  char *getName();
  void setName(const char *new_name);
  char *getIconname();
  void setIconname(const char *new_iconname);
  GUIElement *add(GUIElement *new_element);
  bool remove(GUIElement *elem);
  int getBG();
  void setBG(int bg);
  void ReactMessage(Message *msg);
  bool handleMessage(XEvent *,Message *msg);
  void resizeSubWin(Window win,int w,int h);
  void moveSubWin(Window win,int x,int y);
  bool hasSubWin(Window win);
  Window getSubWindow(Window parent,int x,int y,int w,int h);
  void removeSubWin(Window subwin);
  void addSubAWindow(AWindow *child);
  void removeSubAWindow(AWindow *child);
  bool isParent(Window childwin,bool);
  GUIElement *findGUIElement(Window);
protected:
  int x,y,w,h;
  bool onScreen;
  char *title;
  char *name;
  char *iconname;
  int bg;
  int maxw,maxh,minw,minh;
  Window win;
  AGUIX *aguix;
  List *gui;
  List *subwins;
  List *subawins;
  AWindow *parentawindow;
};

#endif
