#ifndef CYCLEBUTTON_H
#define CYCLEBUTTON_H

#include "guielement.h"

class AWindow;
class AGUIXFont;
class List;

class CycleButton:public GUIElement {
public:
  CycleButton(AGUIX *aguix);
  CycleButton(AGUIX *aguix,int x,int y,int width,
              int fg,int bg,int data);
  CycleButton(AGUIX *aguix,int x,int y,int width,int height,
              int fg,int bg,int data);
  virtual ~CycleButton();
  char *getOption(int);
  int addOption(const char *);
  int getSelectedOption();
  void setFG(int);
  int getFG();
  void setBG(int);
  int getBG();
  int getData();
  void setData(int);
  void setState(int);
  int getState();
  virtual void redraw();
  virtual void flush();
  bool isInside(int x,int y);
  virtual bool handleMessage(XEvent *E,Message *msg);
  int setFont(char*);
  virtual const char *getType();
  virtual bool isType(const char *type);
  void setOption(int index);
  int getMaxSize();
protected:
  List *options;
  int act_opt;
  int fg;
  int bg;
  int lastbg;
  int data;
  int state;
  int instate;
  AGUIXFont *font;
  static const char *type;
};

#endif
