#ifndef GUIELEMENT_H
#define GUIELEMENT_H

#include "message.h"

class AGUIX;
class AWindow;

class GUIElement {
public:
  GUIElement() {}
  GUIElement(AGUIX *aguix);
  virtual ~GUIElement();
  void move(int x,int y);
  virtual void resize(int w,int h);
  virtual void redraw();
  virtual void flush();
  virtual const char *getType();
  virtual bool isType(const char *type);
  virtual bool handleMessage(XEvent *E,Message *msg);
  void getPos(int*,int*);
  void getSize(int*,int*);
  int getWidth();
  int getHeight();
  int getX();
  int getY();
  virtual void setParent(AWindow *parent);
  void toBack();
  void toFront();
  bool hasWin(Window win);
  Window getWindow();
  virtual bool isParent(Window);
protected:
  int x,y;
  int w,h;
  AGUIX *aguix;
  AWindow *parent;
  Window win;
  static const char *type;
};

#endif

