#include "listviewdnd.h"
#include "awindow.h"
#include "guielement.h"
#include "dndtext.h"

const char *ListViewDND::type="ListViewDND";

ListViewDND::~ListViewDND()
{
  removealldndtexts();
  delete dndtexts;
}

ListViewDND::ListViewDND(AGUIX *aguix):ListView(aguix)
{
  dndtexts=new List();
}

ListViewDND::ListViewDND(AGUIX *aguix,int x,int y,int width,int height,int data):ListView(aguix,x,y,width,height,data)
{
  dndtexts=new List();
}

void ListViewDND::handleSelect(Message *msg)
{
  if(msg->button==Button2) return;
  int j=-1;
  int dely;
  int elements=getElements();
  bool ende;
  for(int i=0;i<maxdisplayv;i++) {
    if(msg->window==subwins[i]) j=i;
  }
  if(j==-1) return;
  if((j+yoffset)>elements) return;

  int ch;
  if(font==NULL) ch=aguix->getCharHeight();
  else ch=font->getCharHeight();
  ListViewContent *tlvc,*firstselect;
  tlvc=vislvcs[j];
  bool state=tlvc->getSelect();
  state=(state==false)?true:false;
  tlvc->setSelect(state);
  tlvc->setActive(true);
  runSelectHandler(tlvc,j+yoffset);
  aguix->Flush();

  dely=j*ch;
  Message *tmsg;
  int newelement,element=j,my,elementh=ch;
  int dest,source;
  int selected=1;
  firstselect=tlvc;
  newelement=element;
  Time lasttime=0;
//  printf("entered handleSelect\n");
  for(ende=false;ende==false;) {
    tmsg=aguix->wait4messReact(MES_GET,false);
    if(tmsg!=NULL) {
//      printf("  type:%d\n",tmsg->type);
      if(tmsg->type==ButtonRelease) {
//  printf("  button release\n");
        ende=true;
	lasttime=tmsg->time;
      } else if((tmsg->type==MotionNotify)||(tmsg->type==EnterNotify)||(tmsg->type==LeaveNotify)) {
/*        my=tmsg->mousey;
        my+=dely;
        newelement=my/elementh;
        if(my<0) newelement--;*/
        Window root,child;
        int root_x,root_y,win_x,win_y;
        unsigned int keys_buttons;
        XQueryPointer(aguix->getDisplay(),msg->window,&root,&child,&root_x,&root_y,&win_x,
                      &win_y,&keys_buttons);
        my=win_y;
        my+=dely;
        newelement=my/elementh;
        if(my<0) newelement--;
      } else if((tmsg->type==ButtonPress)&&(tmsg->button==Button3)) {
	int xw,yw,xr,yr;
	Window root,child;
	unsigned int keys_button;
	XQueryPointer(aguix->getDisplay(),win,&root,&child,&xr,&yr,&xw,&yw,&keys_button);
	ListViewContent *tlvc=(ListViewContent*)lvcs->getElementAt(element+yoffset);
	if(tlvc!=NULL) {
	  int ti;
	  ti=(tlvc->getActive()==true)?2:0;
	  ti+=(tlvc->getSelect()==true)?1:0;
	  char *tstr=(char*)dndtexts->getElementAt(element+yoffset);
	  if(tstr==NULL) tstr=(char*)tlvc->getText();
  	  DNDText *dnd1=new DNDText(aguix,this,xw,yw,(void*)(element+yoffset),tstr,tlvc->getFG(ti),tlvc->getBG(ti),font);
	  dnd1->handler();
	  delete dnd1;
	}
        ende=true;
	lasttime=tmsg->time;
      }
      _freesafe(tmsg);
    } else {
      waittime(50);
      Window root,child;
      int root_x,root_y,win_x,win_y;
      unsigned int keys_buttons;
      XQueryPointer(aguix->getDisplay(),msg->window,&root,&child,&root_x,&root_y,&win_x,
                    &win_y,&keys_buttons);
      my=win_y;
      my+=dely;
      newelement=my/elementh;
      if(my<0) newelement--;
    }
    if((element!=newelement)||(newelement<0)||(newelement>=maxdisplayv)) {
      dest=newelement;
      if(newelement<0) {
        scrollV1(-1);
        dest=0;
        element++;
      } else if(newelement>=maxdisplayv) {
        scrollV1(1);
        dest=maxdisplayv-1;
        element--;
      }
      source=element;
      if(source<0) source=0;
      if(source>=maxdisplayv) source=maxdisplayv-1;
      int starte,ende,dire;
      starte=source;
      ende=dest;
      if(starte<ende) {
        starte++;
	dire=1;
      } else if(starte>ende) {
        starte--;
	dire=-1;
      } else dire=0;
      // for i = starte to ende step dire
      for(int i=starte;;i+=dire) {
        if((i+yoffset)>=elements) break;
        tlvc=vislvcs[i];
	if(tlvc!=NULL) {
	  tlvc->setSelect(state);
	  runSelectHandler(tlvc,i+yoffset);
	  selected++;
	}
	if(i==ende) break;
      }
      element=dest;
/*      if((element+yoffset)<elements) {
        tlvc=vislvcs[element];
        if(tlvc!=NULL) {
          tlvc->setActive(true);
          runSelectHandler(tlvc,element+yoffset);
        }
      }*/
      if((element+yoffset)>=elements) {
        element=elements-yoffset-1;
      }
      tlvc=vislvcs[element];
      if(tlvc!=NULL) {
        tlvc->setActive(true);
        runSelectHandler(tlvc,element+yoffset);
      }
    }
  }
//  printf("leave handleSelect\n");
  AGMessage *agmsg=(AGMessage*)_allocsafe(sizeof(AGMessage));
  agmsg->listview.lv=this;
  agmsg->listview.lvc=firstselect;
  agmsg->listview.time=lasttime;
  if(selected==1) {
    agmsg->type=AG_LISTVIEW_ONESELECT;
  } else {
    agmsg->type=AG_LISTVIEW_MULTISELECT;
  }
  aguix->putAGMsg(agmsg);
}

const char *ListViewDND::getType()
{
  return type;
}

bool ListViewDND::isType(const char *qtype)
{
  if(strcmp(type,qtype)==0) return true;
  return false;
}

void ListViewDND::removealldndtexts()
{
  int id=dndtexts->initEnum();
  char *tstr=(char*)dndtexts->getFirstElement(id);
  while(tstr!=NULL) {
    _freesafe(tstr);
    tstr=(char*)dndtexts->getNextElement(id);
  }
  dndtexts->closeEnum(id);
}

void ListViewDND::removedndtextat(int index)
{
  char *tstr=(char*)dndtexts->getElementAt(index);
  dndtexts->removeElementAt(index);
  if(tstr!=NULL) _freesafe(tstr);
}

void ListViewDND::replacedndtext(int index,char *tstr)
{
  if((index<0)||(index>=dndtexts->size())) return;
  char *tstr2=(char*)dndtexts->exchangeElement(index,dupstring(tstr));
  if(tstr2!=NULL) _freesafe(tstr2);
}

void ListViewDND::insertdndtext(int index,char *tstr)
{
  dndtexts->addElementAt(index,dupstring(tstr));
}

void ListViewDND::adddndtext(char *tstr)
{
  dndtexts->addElement(dupstring(tstr));
}
