#ifndef STRINGGADGET_H
#define STRINGGADGET_H

#include "guielement.h"

class AGUIX;
class AGUIXFont;

class StringGadget:public GUIElement {
public:
  StringGadget(AGUIX *aguix);
  StringGadget(AGUIX *aguix,int x,int y,int width,int height,const char *text,int data);
  StringGadget(AGUIX *aguix,int x,int y,int width,const char *text,int data);
  virtual ~StringGadget();
  void resize(int w,int h);
  int getData();
  void setData(int);
  virtual void redraw();
  virtual void flush();
  bool isInside(int x,int y);
  virtual bool handleMessage(XEvent *E,Message *msg);
  char *getText();
  void setText(const char *new_text);
  void setXOffset(int new_offset);
  int getXOffset();
  void activate();
  void deactivate();
  void setCursor(int new_pos);
  int getCursor();
  bool isActive();
  virtual void setParent(AWindow *parent);
  int setFont(char*);
  virtual const char *getType();
  virtual bool isType(const char *type);
  virtual bool isParent(Window);
  bool isPosChangeForbidden();
  void setForbidPosChange(bool nv);
  void setStrongKeyCapture(bool nv);
private:
  int data;
  char *text;
  int cursorpos;
  int xoffset;
  bool active;
  static const char *type;
  Window twin;
  int tbg;
  bool bgset;
  int maxdisplay;
  int selstart,selend;
  AGUIXFont *font;
  bool forbidPosChange;
  bool ignoreRelease;
  bool strongkeycapture;
  
  void updateWin();
  void tredraw();
  void bredraw();
  void applySelection();
  void removeSelection();
  void insertSelection();
};

#endif

