#include "functionproto.h"
#include "worker.h"

const char *FunctionProto::name="FunctionProto";

bool FunctionProto::isName(const char *str)
{
  if(strcmp(str,name)==0) return true; else return false;
}

const char *FunctionProto::getName()
{
  return name;
}

FunctionProto::FunctionProto(Worker *worker)
{
  this->worker=worker;
}

FunctionProto::~FunctionProto()
{
}

int FunctionProto::configure()
{
  AGUIX *aguix=worker->getAGUIX();
  Requester *req;
  char *textstr,*buttonstr;
  
  req=new Requester(aguix);
  textstr=catalog.getLocale(292);
  buttonstr=catalog.getLocale(11);
  req->request(catalog.getLocale(124),textstr,buttonstr);
  delete req;

  return 0;
}

int FunctionProto::load(Datei *fh)
{
  int chunksize=fh->getInt();
  while(chunksize>0) {
    fh->getUChar();
    chunksize--;
  }
  return 0;
}

FunctionProto *FunctionProto::duplicate()
{
  return NULL;
}

bool FunctionProto::save(Datei *fh)
{
  fh->putInt(0);
  return false;
}

FunctionProto *FunctionProto::preload(Worker *w,Datei *fh)
{
  int id=fh->getInt();
  FunctionProto *fp=w->getCommand4ID(id);
  fp->load(fh);
  return fp;
}

int FunctionProto::presave(Datei *fh,FunctionProto *fp)
{
  fh->putInt(Worker::getID4Command(fp));
  fp->save(fh);
  return 0;
}

int FunctionProto::run(ActionMessage *msg)
{
  return 0;
}

ActionMessage::ActionMessage()
{
  flags=NULL;
  mode=AM_MODE_NORMAL;
  startLister=NULL;
  extraInfo=NULL;
}

ActionMessage::~ActionMessage()
{
}

const char *FunctionProto::getDescription()
{
  return "Prototype einer Aktion";
}

