#include "makedirop.h"
#include "listermode.h"
#include "normalmode.h"
#include "worker.h"

const char *MakeDirOp::name="MakeDirOp";

MakeDirOp::MakeDirOp(Worker *worker):FunctionProto(worker)
{
}

MakeDirOp::~MakeDirOp()
{
}

MakeDirOp*
MakeDirOp::duplicate()
{
  MakeDirOp *ta=new MakeDirOp(worker);
  return ta;
}

bool
MakeDirOp::isName(const char *str)
{
  if(strcmp(str,name)==0) return true; else return false;
}

const char *
MakeDirOp::getName()
{
  return name;
}

int
MakeDirOp::run(ActionMessage *msg)
{
  ListerMode *lm1;
  Lister *l1=worker->getActiveLister();
  if(l1!=NULL) {
    startlister=l1;
    lm1=startlister->getActiveMode();
    if(lm1!=NULL)
      if(lm1->isType("NormalMode")==true)
        normalmodemakedir();
  }
  return 0;
}

const char *
MakeDirOp::getDescription()
{
  return catalog.getLocaleCom(27);
}

int
MakeDirOp::normalmodemakedir()
{
  NormalMode *nm1=NULL;
  ListerMode *lm1=NULL;
  
  if(startlister==NULL) return 1;
  lm1=startlister->getActiveMode();
  if(lm1==NULL) return 1;
  if(lm1->isType("NormalMode")!=true) return 1;
  nm1=(NormalMode*)lm1;
  
  nm1->makedir();
  return 0;
}

